;================================================================
;       Wait_ERR_BSY    Xe[^XWX^ǂ݂ɍs
;================================================================
RETRY_TIME      equ     5432h    ; K >80h
Wait_ERR_BSY    PROC    near
                mov     cx,0
Wait_ERR_BSY_R: inc     cx
                cmp     cx,RETRY_TIME     ; Kȃ^CAEg
                jae     Wait_TimeOut
                mov     dx,064Eh        ; IDEreg_Status ; (064Eh)
                in      al,dx
                test    al,10000000b    ; BUSY
                jnz     Wait_ERR_BSY_R
                test    al,00000001b    ; ERROR
                jnz     DeviceError
                mov     ah,00001000b    ; DRQ fB
                not     ah
                test    al,ah
                jz      Wait_ERR_BSY_R
                xor     ax,ax           ; C return value=0
                clc
                ret
Wait_TimeOut:   mov     ax,0FFFFh       ; C return value=FFFF
DeviceError:    stc
                ret
Wait_ERR_BSY    ENDP

;---------------------------------------
;       IDEoNE|[gI
;---------------------------------------
Switch0432h     PROC   near
                mov     al,80h          ; eXĝ߂̓ǂݏo
                mov     dx,0432h
                out     dx,al   
                in      al,dx           ; ǂݏo݂̒l
                mov     cs:Saved0432h,al   ; ۑĂ
                mov     al,PriSec
                mov     dx,0432h
                out     dx,al
                ret
Saved0432h      DB      0
Switch0432h     ENDP
;---------------------------------------
;       IDEoNE|[g̕
;---------------------------------------
Resume0432h     PROC   near
                mov     al,cs:Saved0432h  ; I0432h̒l߂
                mov     dx,0432h
                out     dx,al          ; 
                mov     al,SlaveBit
                or      al,al
                jz      @f
                mov     al,0A0h         ; A0=CHS,00000000b=master
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                wait1u
        @@:
                ret
Resume0432h     ENDP

;================================================================
;       Identify Device 𔭍s, Get
;  input:  PORT_NUM : foCX̃|[gԍ(0..3) ,  DS:DI=buffer
;       BYTE *IdentifyIDE( int PortNo);  return NULL:fail 
;================================================================
;               PUBLIC  IdentifyIDE
IdentifyIDE     PROC   near
;                mov     bx,PortNo
;                call    SelectPortIDE
;                or      al,0A0h         ; 1010b 1=obsoleted bits
;                mov     al,040h        ; LBA
                mov     al,0E0h        ; LBA
                or      al,SlaveBit
                cli     ; 荞݋֎~ 
                mov     dx,IDEreg_SDHead ; (064C)
                out     dx,al
                wait1u
                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,ATA_CMD      ; Identify command
                out     dx,al
                wait1u
                sti     ; 荞݋֎~
                call    Wait_ERR_BSY ;  Xe[^XEɍs(no check)
                jc      IdentifyDeviceFail

                mov     si,offset ID_Buffer
                mov     cx,256
                mov     dx,IDEreg_Data  ; (0640h)
        @@:     in      ax,dx   ; 16bit read
                mov     [si],ax
                inc     si
                inc     si      ; next word
               loop     @b
                call    Wait_ERR_BSY ;  Xe[^XEɍs(no check)
                jc      IdentifyDeviceFail
                xor     ax,ax   ; return(NULL);
                clc
                ret
IdentifyDeviceFail:
                stc
                ret
IdentifyIDE     ENDP

;--------------------------------------------------------
Capability      PROC   near
                mov     si,offset ID_Buffer

                mov     ax,[si+83*2]    ; WORD 83
                test    ax,0000000100000000b   ; bit 8
                jz      @f
                or      flagset,F_SETMAX
        @@:
                mov     ax,[si+83*2]    ; WORD 83
                test    ax,0000010000000000b   ; bit 10
                jz      @f
                or      flagset,F_48BIT
        @@:     
                mov     ax,[si+86*2]    ; WORD 86
                test    ax,0000000000000100b   ; bit 2
                jz      @f
                or      flagset,F_CFA
        @@:     test    ax,0000000000001000b   ; bit 3
                jz      @f
                or      flagset,F_APM
        @@:     test    ax,0000000001000000b   ; bit 6
                jz      @f
                or      flagset,F_SETFEA
        @@:     
                mov     ax,[si+85*2]    ; WORD 85
                test    ax,0000000000000001b    ; bit 0
                jz      @f
                or      flagset,F_SMART
        @@:     
                test    ax,0000001000000000b   ; bit 9
                jnz     @f
                or      flagset,F_DEVRST
        @@:     
                test    ax,0000010000000000b   ; bit 10 HPA
                jz      @f
                or      flagset,F_HPA
        @@:     ret
Capability      ENDP
;--------------------------------------------------------
MakeWordString  PROC   near
        @@:     lodsw
                xchg    al,ah
                stosw
               loop     @b
                mov     ax,0
                stosb
                ret
MakeWordString  ENDP
;--------------------------------------------------------
DisplayWordString    PROC near
                mov     dl,81h
                push    es
                mov     es,SegTVRAM
        @@:     mov     es:[di+2000h],dl
                mov     es:[di+2000h+2],dl
                lodsw
                mov     es:[di],AH
                mov     es:[di+2],AL
                add     di,4
               loop     @b
                pop     es
                ret
DisplayWordString    ENDP
;--------------------------------------------------------
;================================================================
GetCapaLBA     PROC   near
                mov     si,offset ID_Buffer +WORD60_CAPA
                lodsw
;                xchg    al,ah
                mov     TotalLBA_L,ax
                lodsw
;                xchg    al,ah
                mov     TotalLBA_H,ax
                mov     eax,TotalLBA
                or      eax,eax
                jnz     @f
                mov     dx,offset msg_OnlyCHS
                call    _puts
                stc
                ret
        @@:     clc
                ret
GetCapaLBA     ENDP


;================================================================
GetDeviceName       PROC   near
                mov     si,offset ID_Buffer+ WORD27_MODEL
                mov     di,offset msgbuf0
                mov     cx,20   ;40/2
                call    MakeWordString  ;  DisplayWordString
                ret
GetDeviceName       ENDP

;================================================================
GetSerialNumber     PROC   near
                mov     si,offset ID_Buffer+ WORD10_SERIAL
                mov     di,offset msgbuf1
                mov     cx,10
                call    MakeWordString  ;  DisplayWordString
                ret
GetSerialNumber     ENDP

;================================================================
GetFirmNumber     PROC   near
                mov     si,offset ID_Buffer+ WORD23_FIRM
                mov     di,offset msgbuf2
                mov     cx,4
                call    MakeWordString  ;  DisplayWordString
                ret
GetFirmNumber     ENDP


